SystemOrganization addCategory: #SeasideBook!

Object subclass: #Contact
	instanceVariableNames: 'name emailAddress gender'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'SeasideBook'!

!Contact class methodsFor: 'database func' stamp: 'ThiagoFurtado 9/17/2012 17:36'!
addContact: aContact
	self contacts add: aContact.! !

!Contact class methodsFor: 'database func' stamp: 'ThiagoFurtado 9/17/2012 18:11'!
contacts
	Database isNil ifTrue: [ self createSampleDatabase ].
	^ Database.! !

!Contact class methodsFor: 'class initialization' stamp: 'ThiagoFurtado 9/17/2012 17:14'!
createSampleDatabase
	Database := OrderedCollection new
	add: (self name: 'pessoa 1' emailAddress: 'pessoa1@email.com');
	add: (self name: 'pessoa 2' emailAddress: 'pessoa2@email.com');
	yourself .! !

!Contact class methodsFor: 'class initialization' stamp: 'ThiagoFurtado 9/17/2012 17:09'!
name: nameString emailAddress: emailString
	^ self new 
		name: nameString;
		emailAddress: emailString;
		yourself .! !

!Contact class methodsFor: 'database func' stamp: 'ThiagoFurtado 9/17/2012 17:37'!
removeContact: aContact
	self contacts remove: aContact.! !

!Contact methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 9/17/2012 21:20'!
beFemale
	gender := #Female.! !

!Contact methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 9/17/2012 21:20'!
beMale
	gender := #Male.! !

!Contact methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 9/17/2012 16:53'!
emailAddress
	^ emailAddress.! !

!Contact methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 9/17/2012 16:54'!
emailAddress: aString 
	emailAddress := aString.! !

!Contact methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 9/17/2012 21:18'!
gender
	^ gender ifNil: [gender := #Male].! !

!Contact methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 9/17/2012 21:20'!
isFemale
	^ self gender = #Female.! !

!Contact methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 9/17/2012 21:20'!
isMale
	^ self gender = #Male.! !

!Contact methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 9/17/2012 16:54'!
name
	^ name.! !

!Contact methodsFor: 'as yet unclassified' stamp: 'ThiagoFurtado 9/17/2012 16:55'!
name: aString
	name := aString.! !

WAComponent subclass: #ContactListView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideBook'!

!ContactListView class methodsFor: 'class initialization' stamp: 'ThiagoFurtado 9/17/2012 18:06'!
initialize 
	 WAAdmin register: self asApplicationAt: 'contactbook'! !

!ContactListView methodsFor: 'contact' stamp: 'ThiagoFurtado 9/17/2012 18:53'!
addContact 
	| name emailAddress |
	name := self request: 'Name'.
	emailAddress := self request: 'Email'.
	Contact addContact: (Contact name: name emailAddress: emailAddress).! !

!ContactListView methodsFor: 'contact' stamp: 'ThiagoFurtado 9/19/2012 16:52'!
editContact: aContact
	self call: (ContactView new contact: aContact; yourself ).! !

!ContactListView methodsFor: 'contact' stamp: 'ThiagoFurtado 9/17/2012 19:24'!
removeContact: aContact
	(self confirm: 'Are you sure?') ifTrue: [Contact removeContact: aContact].! !

!ContactListView methodsFor: 'rendering' stamp: 'ThiagoFurtado 9/19/2012 16:58'!
renderContact: aContact on: html
	html render: aContact name.
	html space.
	html anchor 
		url: 'mailto:',  aContact emailAddress; with: aContact emailAddress .
	html text: '('.
	html anchor 
		callback: [ self editContact: aContact];
		with: 'edit'.
	html space .
	html anchor 
		callback: [
			self removeContact: aContact]; with: 'remove'.
	html text: ')'.! !

!ContactListView methodsFor: 'rendering' stamp: 'ThiagoFurtado 9/17/2012 18:44'!
renderContentOn: html

	html anchor 
			callback: [self addContact]; with: 'Add Contact'.

	html unorderedList: [
		Contact contacts do: [ :contact | 
			html listItem: [self renderContact: contact on: html]]].! !

WAComponent subclass: #ContactView
	instanceVariableNames: 'contact'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideBook'!

!ContactView class methodsFor: 'class initialization' stamp: 'ThiagoFurtado 9/17/2012 20:59'!
initialize 
	WAAdmin register: self asApplicationAt: 'contact'.! !

!ContactView methodsFor: 'contact' stamp: 'ThiagoFurtado 9/17/2012 20:34'!
contact
	^ contact ifNil: [contact := Contact contacts first ].! !

!ContactView methodsFor: 'contact' stamp: 'ThiagoFurtado 9/17/2012 20:36'!
contact: aContact
	contact := aContact! !

!ContactView methodsFor: 'rendering' stamp: 'ThiagoFurtado 9/17/2012 21:29'!
renderContentOn: html
	html form: [
		html text: 'Name'.
		html textInput on: #name of: self contact .
		html break .
		html text: 'Email Address'.
		html textInput on: #emailAddress of: self contact . 
		html break .
		
		"Drop down menu"
		html text: 'Select gender'.
		html select
			list: #(#Male #Female);
			selected: self contact gender ;
			callback: [ :value |
				 value = #Male ifTrue: [self contact beMale] ifFalse: [self contact beFemale ] ].
			
		
		html break .
		html submitButton on: #save of: self ].
	! !

!ContactView methodsFor: 'contact' stamp: 'ThiagoFurtado 9/19/2012 16:56'!
save
	"self inform: self contact name, '--', self contact emailAddress."
	self answer.! !
ContactView initialize!
ContactListView initialize!
